﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.ComponentModel;
using System.Reflection;

namespace Builder
{
    public class MyNode : TreeNode
    {

        public MyNode ()
        {
        }

        public void connect ()
        {
            object obj = this.Tag;
            if (obj is Common)
                obj = (obj as Common).recallData();
            /*
            Control ctl = obj as Control;
            if (ctl != null)
            {
                // form.DataBindings.Add ("Text", obj, "Text");
                ctl.BackColorChanged += ModifyColor;
                ctl.TextChanged += ModifyText;
            }
            */


            PropertyDescriptorCollection properties = TypeDescriptor.GetProperties (obj);

            PropertyDescriptor desc = properties.Find ("Name", false);
            if (desc == null)
               desc = properties.Find ("Text", false);
            if (desc != null)
               desc.AddValueChanged (obj, CopyName);

            desc = properties.Find ("Color", false);
            if (desc == null)
                desc = properties.Find ("BackColor", false);
            if (desc != null)
                desc.AddValueChanged (obj, CopyColor);
        }

        private void CopyName (object sender, EventArgs e)
        {
            object obj = this.Tag;

            PropertyInfo prop = obj.GetType ().GetProperty ("Name");
            if (prop == null)
                prop = obj.GetType().GetProperty("Text");

            if (prop != null)
                this.Text = prop.GetValue (obj).ToString ();
        }

        private void CopyColor (object sender, EventArgs e)
        {
            object obj = this.Tag;

            PropertyInfo prop = obj.GetType ().GetProperty ("Color");
            if (prop == null)
                prop = obj.GetType().GetProperty("BackColor");

            if (prop != null)
                this.BackColor = (Color) prop.GetValue (obj);
        }

        private void ModifyText (object sender, EventArgs e)
        {
            Control obj = this.Tag as Control;
            this.Text = obj.Text;
        }

        private void ModifyColor (object sender, EventArgs e)
        {
            Control obj = this.Tag as Control;
            this.BackColor = obj.BackColor;
        }

    }
}
